/****************************************************************************
    LCoV library editor for BSch3V
	Copyright (C) 1997-2014 H.Okada
*****************************************************************************/

#pragma once
#include "sptnobj.h"
#include <string>
using namespace std;

class SPtnObjText :	public SPtnObj
{
public:
	//ʂ̃C^[tF[X
	SPtnObjText(void);
	~SPtnObjText(void);
	int id(){return VECTPTN_TXT;}
	SPtnObjText(const SPtnObjText&);					//Rs[RXgN^
	SPtnObjText& operator=(const SPtnObjText&);		//Zq
	SPtnObj* duplicate();							//
	bool qValid();									//Lȃf[^ǂԂB

	//Obv̐Ԃ
	int gripCount(){return 1;}
	//Obv̈ʒuԂ
	SPoint gripPos(int grip){return m_p0;}
	//Obv̈ʒu𓮂
	void setGripPos(int grip,int x,int y);

	void move(int offsetx,int offsety);				//ʒu𓮂
	void mirrorH(int x); 							//XWw肵čE]s
	void mirrorH();									//E]s
	void rotate(const SPoint& p);					//XYSWw肵āA]s
	void rotate();									//]s
	bool testIntersect(const SRect& );				//͈͂w肵đI`FbNs
	bool testIntersect(const SPoint& );				//_w肵đI`FbNs
	SRect area();									//L͈͂Ԃ
	void setDrawSize(SSize size);
	void setText(const TCHAR* csz);
	bool readCe3(SReadCE3& rce3);
	bool writeCe3(SWriteCE3& wce3,SPoint* pOrigin=NULL);
	void setFontName(const TCHAR* psz);
	void setFontSize(int fontSize);
	void setFontBold(bool istrue);
	void setFontItalic(bool istrue);
	void setFontUnderline(bool istrue);
	void setFontStrikeOut(bool istrue);

public:
	SPoint m_p0;
	bool m_bHoriz;
	wstring m_strText;
	int m_align;
	bool m_drawSizeIsValid;
	SSize m_drawSize;
	wstring	m_fontName;
	int		m_fontSize;
	bool	m_fontBold;
	bool	m_fontItalic;
	bool	m_fontUnderline;
	bool	m_fontStrikeOut;


};
